diff -Nur olsrd-0.5.3.orig/src/linux/net.c olsrd-0.5.3/src/linux/net.c
--- olsrd-0.5.3.orig/src/linux/net.c	2007-04-26 00:08:18.000000000 +0200
+++ olsrd-0.5.3/src/linux/net.c	2007-09-04 16:06:20.000000000 +0200
@@ -55,7 +55,9 @@
  *(from linux/wireless.h)
  */
 #define SIOCGIWNAME	0x8B01		/* get name == wireless protocol */
+#define SIOCGIWMODE	0x8B07		/* get operation mode */
 #define SIOCGIWRATE	0x8B21		/* get default bit rate (bps) */
+#define IW_MODE_ADHOC	1	/* Single cell network */
 
 /* The original state of the IP forwarding proc entry */
 static char orig_fwd_state;
@@ -724,8 +726,12 @@
 
   memset(&ifr, 0, sizeof(ifr));
   strncpy(ifr.ifr_name, ifname, sizeof(ifr.ifr_name));
-
-  return (ioctl(olsr_cnf->ioctl_s, SIOCGIWNAME, &ifr) >= 0) ? 1 : 0;
+  
+  if(0 <= ioctl(olsr_cnf->ioctl_s, SIOCGIWNAME, &ifr))
+  {
+  	return IW_MODE_ADHOC == ioctl(olsr_cnf->ioctl_s, SIOCGIWMODE, &ifr) ? 2 : 1;
+  }
+  return 0;
 }
 
 #if 0
diff -Nur olsrd-0.5.3.orig/src/lq_packet.c olsrd-0.5.3/src/lq_packet.c
--- olsrd-0.5.3.orig/src/lq_packet.c	2007-09-04 16:06:19.000000000 +0200
+++ olsrd-0.5.3/src/lq_packet.c	2007-09-04 16:06:20.000000000 +0200
@@ -456,7 +456,7 @@
               // pad
 
               buff[size++] = 0;
-              buff[size++] = 0;
+              buff[size++] = olsr_cnf->lq_midopt ? (0x3f & neigh->link_iif_index) | (neigh->link_iif_flags << 6) : 0;
 
               is_first = 0;
             }
@@ -564,7 +564,7 @@
 
       // pad
       buff[size++] = 0;
-      buff[size++] = 0;
+      buff[size++] = olsr_cnf->lq_midopt ? (0x3f & neigh->link_iif_index) | (neigh->link_iif_flags << 6) : 0;
     }
 
   // finalize the OLSR header
diff -Nur olsrd-0.5.3.orig/src/lq_packet.h olsrd-0.5.3/src/lq_packet.h
--- olsrd-0.5.3.orig/src/lq_packet.h	2007-09-04 16:06:19.000000000 +0200
+++ olsrd-0.5.3/src/lq_packet.h	2007-09-04 16:06:20.000000000 +0200
@@ -93,6 +93,8 @@
 {
   olsr_u8_t                link_type;
   olsr_u8_t                neigh_type;
+  olsr_u8_t                link_iif_index;
+  olsr_u8_t                link_iif_flags;
   double                   link_quality;
   double                   neigh_link_quality;
   union olsr_ip_addr       addr;
diff -Nur olsrd-0.5.3.orig/src/packet.h olsrd-0.5.3/src/packet.h
--- olsrd-0.5.3.orig/src/packet.h	2005-05-29 14:47:45.000000000 +0200
+++ olsrd-0.5.3/src/packet.h	2007-09-04 16:06:20.000000000 +0200
@@ -71,6 +71,8 @@
 
 struct tc_mpr_addr
 {
+  olsr_u8_t          link_iif_index;
+  olsr_u8_t          link_iif_flags;
   double             link_quality;
   double             neigh_link_quality;
   union olsr_ip_addr address;
